/**
 * Define digest function.
 * @function defineDigest
 */

"use strict";

var apemanpasswd = require('apemanpasswd'),
    apemanpromise = require('apemanpromise'),
    async = require('async');

/** @lends defineDigest */
function defineDigest(spec) {
    var passwd = apemanpasswd.fromSpecString(spec);

    function digest(password, salt) {
        return apemanpromise(function (resolve, reject) {
            passwd.digest(password, salt, function (err, hash) {
                if (err) {
                    reject(err);
                } else {
                    resolve(hash);
                }
            });
        });
    }

    digest.newSalt = passwd.newSalt.bind(passwd);
    return digest;
}

module.exports = defineDigest;
