/**
 * @function doSignin
 * @returns Promise
 */

"use strict";

function doSignin(User, Sign, data, digest) {
    return Sign.findAll({where: {key: data.key}, limit: 1}).then(function (found) {
        return found && found.shift();
    }).then(function (sign) {
        if (!sign) {
            return null;
        }
        return digest(data.password, sign.salt).then(function (hash) {
            var valid = sign && sign.hash === hash;
            if (!valid) {
                return null;
            }
            return User.findById(sign.get('id'))
                .then(function (user) {
                    return sign.update({
                        signin_at: new Date()
                    }).then(function (sign) {
                        var result = sign.toJSON();
                        result.user = user.toJSON();
                        return result;
                    });
                });
        });
    });
}

module.exports = doSignin;

